(set-logic HORN)
(set-info :source "CHC Constraint Logic: QF_LIA
                   Contains non-linear Horn clauses: true")
(declare-fun f_fENTRY (Int Int Int Bool) Bool)
(declare-fun f2_f2EXIT (Int Int Int Bool) Bool)
(declare-fun f2_L16 (Int Int Int Bool) Bool)
(declare-fun f_L9-1 (Int Int Int Bool) Bool)
(declare-fun f2_L14 (Int Int Int Bool) Bool)
(declare-fun ULTIMATE.start_ULTIMATE.startENTRY (Int Int Bool) Bool)
(declare-fun f_L9 (Int Int Int Bool) Bool)
(declare-fun f_L7 (Int Int Int Bool) Bool)
(declare-fun f2_f2FINAL (Int Int Int Bool) Bool)
(declare-fun ULTIMATE.start_L21 (Int Int Bool) Bool)
(declare-fun ULTIMATE.start_L21-1 (Int Int Bool) Bool)
(declare-fun ULTIMATE.start_ULTIMATE.startFINAL (Int Int Bool) Bool)
(declare-fun f2_L16-1 (Int Int Int Bool) Bool)
(declare-fun f_fFINAL (Int Int Int Bool) Bool)
(declare-fun f2_f2ENTRY (Int Int Int Bool) Bool)
(declare-fun f_fEXIT (Int Int Int Bool) Bool)
(declare-fun ULTIMATE.start_ULTIMATE.startEXIT (Int Int Bool) Bool)
(assert (forall ((hhv_ULTIMATE.start_L21_0_Int Int) (hhv_ULTIMATE.start_L21_1_Int Int) (hhv_ULTIMATE.start_L21_2_Bool Bool) (hbv_ULTIMATE.start_ULTIMATE.startENTRY_0_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool Bool)) (=> (ULTIMATE.start_ULTIMATE.startENTRY hhv_ULTIMATE.start_L21_0_Int hbv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int hhv_ULTIMATE.start_L21_2_Bool) (ULTIMATE.start_L21 hhv_ULTIMATE.start_L21_0_Int hhv_ULTIMATE.start_L21_1_Int hhv_ULTIMATE.start_L21_2_Bool))))
(assert (forall ((hhv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool Bool) (hbv_ULTIMATE.start_L21-1_0_Int Int) (hbv_ULTIMATE.start_L21-1_1_Int Int) (hbv_ULTIMATE.start_L21-1_2_Bool Bool)) (=> (and (ULTIMATE.start_L21-1 hbv_ULTIMATE.start_L21-1_0_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool) (or (= hhv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int) hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool)) (ULTIMATE.start_ULTIMATE.startFINAL hhv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool))))
(assert (forall ((hhv_f_L7_0_Int Int) (hhv_f_L7_1_Int Int) (hhv_f_L7_2_Int Int) (hhv_f_L7_3_Bool Bool) (hbv_f_fENTRY_0_Int Int) (hbv_f_fENTRY_1_Int Int) (hbv_f_fENTRY_2_Int Int) (hbv_f_fENTRY_3_Bool Bool)) (=> (and (or (= hhv_f_L7_2_Int hhv_f_L7_0_Int) hhv_f_L7_3_Bool) (f_fENTRY hhv_f_L7_0_Int hhv_f_L7_1_Int hbv_f_fENTRY_2_Int hhv_f_L7_3_Bool)) (f_L7 hhv_f_L7_0_Int hhv_f_L7_1_Int hhv_f_L7_2_Int hhv_f_L7_3_Bool))))
(assert (forall ((hhv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool Bool) (hbv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool Bool)) (=> (ULTIMATE.start_ULTIMATE.startFINAL hhv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool) (ULTIMATE.start_ULTIMATE.startEXIT hhv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool))))
(assert (forall ((hhv_f_fFINAL_0_Int Int) (hhv_f_fFINAL_1_Int Int) (hhv_f_fFINAL_2_Int Int) (hhv_f_fFINAL_3_Bool Bool) (hbv_f_L7_0_Int Int) (hbv_f_L7_1_Int Int) (hbv_f_L7_2_Int Int) (hbv_f_L7_3_Bool Bool)) (=> (and (f_L7 hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool) (or (< hhv_f_fFINAL_2_Int 3) hhv_f_fFINAL_3_Bool)) (f_fFINAL hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool))))
(assert (forall ((hhv_f_L9_0_Int Int) (hhv_f_L9_1_Int Int) (hhv_f_L9_2_Int Int) (hhv_f_L9_3_Bool Bool) (hbv_f_L7_0_Int Int) (hbv_f_L7_1_Int Int) (hbv_f_L7_2_Int Int) (hbv_f_L7_3_Bool Bool)) (=> (and (or (and (= hbv_f_L7_2_Int (+ hhv_f_L9_2_Int 1)) (not (< hbv_f_L7_2_Int 3))) hhv_f_L9_3_Bool) (f_L7 hhv_f_L9_0_Int hbv_f_L7_1_Int hbv_f_L7_2_Int hhv_f_L9_3_Bool)) (f_L9 hhv_f_L9_0_Int hhv_f_L9_1_Int hhv_f_L9_2_Int hhv_f_L9_3_Bool))))
(assert (forall ((hhv_f_fEXIT_0_Int Int) (hhv_f_fEXIT_1_Int Int) (hhv_f_fEXIT_2_Int Int) (hhv_f_fEXIT_3_Bool Bool) (hbv_f_fFINAL_0_Int Int) (hbv_f_fFINAL_1_Int Int) (hbv_f_fFINAL_2_Int Int) (hbv_f_fFINAL_3_Bool Bool)) (=> (f_fFINAL hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hhv_f_fEXIT_3_Bool) (f_fEXIT hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hhv_f_fEXIT_3_Bool))))
(assert (forall ((hhv_ULTIMATE.start_L21-1_0_Int Int) (hhv_ULTIMATE.start_L21-1_1_Int Int) (hhv_ULTIMATE.start_L21-1_2_Bool Bool) (hbv_ULTIMATE.start_L21_0_Int Int) (hbv_ULTIMATE.start_L21_1_Int Int) (hbv_ULTIMATE.start_L21_2_Bool Bool) (hbv_f_fEXIT_0_Int Int) (hbv_f_fEXIT_1_Int Int) (hbv_f_fEXIT_2_Int Int) (hbv_f_fEXIT_3_Bool Bool)) (=> (and (ULTIMATE.start_L21 hhv_ULTIMATE.start_L21-1_0_Int hhv_ULTIMATE.start_L21-1_1_Int hbv_ULTIMATE.start_L21_2_Bool) (= hbv_f_fEXIT_0_Int 2) (f_fEXIT hbv_f_fEXIT_0_Int hbv_f_fEXIT_1_Int hbv_f_fEXIT_2_Int hbv_f_fEXIT_3_Bool) (let ((.cse0 (or hbv_ULTIMATE.start_L21_2_Bool hbv_f_fEXIT_3_Bool))) (or (and hhv_ULTIMATE.start_L21-1_2_Bool .cse0) (and (not .cse0) (not hhv_ULTIMATE.start_L21-1_2_Bool))))) (ULTIMATE.start_L21-1 hhv_ULTIMATE.start_L21-1_0_Int hhv_ULTIMATE.start_L21-1_1_Int hhv_ULTIMATE.start_L21-1_2_Bool))))
(assert (forall ((hhv_f2_L16-1_0_Int Int) (hhv_f2_L16-1_1_Int Int) (hhv_f2_L16-1_2_Int Int) (hhv_f2_L16-1_3_Bool Bool) (hbv_f2_L16_0_Int Int) (hbv_f2_L16_1_Int Int) (hbv_f2_L16_2_Int Int) (hbv_f2_L16_3_Bool Bool) (hbv_f_fEXIT_0_Int Int) (hbv_f_fEXIT_1_Int Int) (hbv_f_fEXIT_2_Int Int) (hbv_f_fEXIT_3_Bool Bool)) (=> (and (let ((.cse0 (or hbv_f2_L16_3_Bool hbv_f_fEXIT_3_Bool))) (or (and (not hhv_f2_L16-1_3_Bool) (not .cse0)) (and .cse0 hhv_f2_L16-1_3_Bool))) (f2_L16 hhv_f2_L16-1_0_Int hhv_f2_L16-1_1_Int hhv_f2_L16-1_2_Int hbv_f2_L16_3_Bool) (= hbv_f_fEXIT_0_Int hhv_f2_L16-1_1_Int) (f_fEXIT hbv_f_fEXIT_0_Int hbv_f_fEXIT_1_Int hbv_f_fEXIT_2_Int hbv_f_fEXIT_3_Bool)) (f2_L16-1 hhv_f2_L16-1_0_Int hhv_f2_L16-1_1_Int hhv_f2_L16-1_2_Int hhv_f2_L16-1_3_Bool))))
(assert (forall ((hhv_f_fEXIT_0_Int Int) (hhv_f_fEXIT_1_Int Int) (hhv_f_fEXIT_2_Int Int) (hhv_f_fEXIT_3_Bool Bool) (hbv_f_L9-1_0_Int Int) (hbv_f_L9-1_1_Int Int) (hbv_f_L9-1_2_Int Int) (hbv_f_L9-1_3_Bool Bool)) (=> (and hhv_f_fEXIT_3_Bool (f_L9-1 hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hbv_f_L9-1_3_Bool)) (f_fEXIT hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hhv_f_fEXIT_3_Bool))))
(assert (forall ((hhv_f_fFINAL_0_Int Int) (hhv_f_fFINAL_1_Int Int) (hhv_f_fFINAL_2_Int Int) (hhv_f_fFINAL_3_Bool Bool) (hbv_f_L9-1_0_Int Int) (hbv_f_L9-1_1_Int Int) (hbv_f_L9-1_2_Int Int) (hbv_f_L9-1_3_Bool Bool)) (=> (and (f_L9-1 hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool) hhv_f_fFINAL_3_Bool) (f_fFINAL hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool))))
(assert (forall ((hhv_f2_L14_0_Int Int) (hhv_f2_L14_1_Int Int) (hhv_f2_L14_2_Int Int) (hhv_f2_L14_3_Bool Bool) (hbv_f2_f2ENTRY_0_Int Int) (hbv_f2_f2ENTRY_1_Int Int) (hbv_f2_f2ENTRY_2_Int Int) (hbv_f2_f2ENTRY_3_Bool Bool)) (=> (and (or hhv_f2_L14_3_Bool (= hhv_f2_L14_1_Int hhv_f2_L14_2_Int)) (f2_f2ENTRY hhv_f2_L14_0_Int hbv_f2_f2ENTRY_1_Int hhv_f2_L14_2_Int hhv_f2_L14_3_Bool)) (f2_L14 hhv_f2_L14_0_Int hhv_f2_L14_1_Int hhv_f2_L14_2_Int hhv_f2_L14_3_Bool))))
(assert (forall ((hhv_f2_f2EXIT_0_Int Int) (hhv_f2_f2EXIT_1_Int Int) (hhv_f2_f2EXIT_2_Int Int) (hhv_f2_f2EXIT_3_Bool Bool) (hbv_f2_L16-1_0_Int Int) (hbv_f2_L16-1_1_Int Int) (hbv_f2_L16-1_2_Int Int) (hbv_f2_L16-1_3_Bool Bool)) (=> (and hhv_f2_f2EXIT_3_Bool (f2_L16-1 hhv_f2_f2EXIT_0_Int hhv_f2_f2EXIT_1_Int hhv_f2_f2EXIT_2_Int hbv_f2_L16-1_3_Bool)) (f2_f2EXIT hhv_f2_f2EXIT_0_Int hhv_f2_f2EXIT_1_Int hhv_f2_f2EXIT_2_Int hhv_f2_f2EXIT_3_Bool))))
(assert (forall ((hhv_f2_f2FINAL_0_Int Int) (hhv_f2_f2FINAL_1_Int Int) (hhv_f2_f2FINAL_2_Int Int) (hhv_f2_f2FINAL_3_Bool Bool) (hbv_f2_L16-1_0_Int Int) (hbv_f2_L16-1_1_Int Int) (hbv_f2_L16-1_2_Int Int) (hbv_f2_L16-1_3_Bool Bool)) (=> (and hhv_f2_f2FINAL_3_Bool (f2_L16-1 hhv_f2_f2FINAL_0_Int hhv_f2_f2FINAL_1_Int hhv_f2_f2FINAL_2_Int hhv_f2_f2FINAL_3_Bool)) (f2_f2FINAL hhv_f2_f2FINAL_0_Int hhv_f2_f2FINAL_1_Int hhv_f2_f2FINAL_2_Int hhv_f2_f2FINAL_3_Bool))))
(assert (forall ((hhv_f2_f2FINAL_0_Int Int) (hhv_f2_f2FINAL_1_Int Int) (hhv_f2_f2FINAL_2_Int Int) (hhv_f2_f2FINAL_3_Bool Bool) (hbv_f2_L14_0_Int Int) (hbv_f2_L14_1_Int Int) (hbv_f2_L14_2_Int Int) (hbv_f2_L14_3_Bool Bool)) (=> (and (f2_L14 hhv_f2_f2FINAL_0_Int hhv_f2_f2FINAL_1_Int hhv_f2_f2FINAL_2_Int hhv_f2_f2FINAL_3_Bool) (or hhv_f2_f2FINAL_3_Bool (< hhv_f2_f2FINAL_1_Int 3))) (f2_f2FINAL hhv_f2_f2FINAL_0_Int hhv_f2_f2FINAL_1_Int hhv_f2_f2FINAL_2_Int hhv_f2_f2FINAL_3_Bool))))
(assert (forall ((hhv_f2_L16_0_Int Int) (hhv_f2_L16_1_Int Int) (hhv_f2_L16_2_Int Int) (hhv_f2_L16_3_Bool Bool) (hbv_f2_L14_0_Int Int) (hbv_f2_L14_1_Int Int) (hbv_f2_L14_2_Int Int) (hbv_f2_L14_3_Bool Bool)) (=> (and (or (and (not (< hbv_f2_L14_1_Int 3)) (= hbv_f2_L14_1_Int (+ hhv_f2_L16_1_Int 1))) hhv_f2_L16_3_Bool) (f2_L14 hbv_f2_L14_0_Int hbv_f2_L14_1_Int hhv_f2_L16_2_Int hhv_f2_L16_3_Bool)) (f2_L16 hhv_f2_L16_0_Int hhv_f2_L16_1_Int hhv_f2_L16_2_Int hhv_f2_L16_3_Bool))))
(assert (forall ((hhv_f2_f2EXIT_0_Int Int) (hhv_f2_f2EXIT_1_Int Int) (hhv_f2_f2EXIT_2_Int Int) (hhv_f2_f2EXIT_3_Bool Bool) (hbv_f2_f2FINAL_0_Int Int) (hbv_f2_f2FINAL_1_Int Int) (hbv_f2_f2FINAL_2_Int Int) (hbv_f2_f2FINAL_3_Bool Bool)) (=> (f2_f2FINAL hhv_f2_f2EXIT_0_Int hhv_f2_f2EXIT_1_Int hhv_f2_f2EXIT_2_Int hhv_f2_f2EXIT_3_Bool) (f2_f2EXIT hhv_f2_f2EXIT_0_Int hhv_f2_f2EXIT_1_Int hhv_f2_f2EXIT_2_Int hhv_f2_f2EXIT_3_Bool))))
(assert (forall ((hhv_f_L9-1_0_Int Int) (hhv_f_L9-1_1_Int Int) (hhv_f_L9-1_2_Int Int) (hhv_f_L9-1_3_Bool Bool) (hbv_f_L9_0_Int Int) (hbv_f_L9_1_Int Int) (hbv_f_L9_2_Int Int) (hbv_f_L9_3_Bool Bool) (hbv_f2_f2EXIT_0_Int Int) (hbv_f2_f2EXIT_1_Int Int) (hbv_f2_f2EXIT_2_Int Int) (hbv_f2_f2EXIT_3_Bool Bool)) (=> (and (let ((.cse0 (or hbv_f2_f2EXIT_3_Bool hbv_f_L9_3_Bool))) (or (and hhv_f_L9-1_3_Bool .cse0) (and (not .cse0) (not hhv_f_L9-1_3_Bool)))) (f2_f2EXIT hbv_f2_f2EXIT_0_Int hbv_f2_f2EXIT_1_Int hbv_f2_f2EXIT_2_Int hbv_f2_f2EXIT_3_Bool) (f_L9 hhv_f_L9-1_0_Int hhv_f_L9-1_1_Int hhv_f_L9-1_2_Int hbv_f_L9_3_Bool) (= hbv_f2_f2EXIT_2_Int hhv_f_L9-1_2_Int)) (f_L9-1 hhv_f_L9-1_0_Int hhv_f_L9-1_1_Int hhv_f_L9-1_2_Int hhv_f_L9-1_3_Bool))))
(assert (forall ((hhv_f_fENTRY_0_Int Int) (hhv_f_fENTRY_1_Int Int) (hhv_f_fENTRY_2_Int Int) (hhv_f_fENTRY_3_Bool Bool)) (=> (not hhv_f_fENTRY_3_Bool) (f_fENTRY hhv_f_fENTRY_0_Int hhv_f_fENTRY_1_Int hhv_f_fENTRY_2_Int hhv_f_fENTRY_3_Bool))))
(assert (forall ((hhv_ULTIMATE.start_ULTIMATE.startENTRY_0_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool Bool)) (=> (not hhv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool) (ULTIMATE.start_ULTIMATE.startENTRY hhv_ULTIMATE.start_ULTIMATE.startENTRY_0_Int hhv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int hhv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool))))
(assert (forall ((hhv_f2_f2ENTRY_0_Int Int) (hhv_f2_f2ENTRY_1_Int Int) (hhv_f2_f2ENTRY_2_Int Int) (hhv_f2_f2ENTRY_3_Bool Bool)) (=> (not hhv_f2_f2ENTRY_3_Bool) (f2_f2ENTRY hhv_f2_f2ENTRY_0_Int hhv_f2_f2ENTRY_1_Int hhv_f2_f2ENTRY_2_Int hhv_f2_f2ENTRY_3_Bool))))
(assert (forall ((hbv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool Bool)) (=> (and (ULTIMATE.start_ULTIMATE.startEXIT hbv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int hbv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int hbv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool) hbv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool) false)))
(check-sat)
