(set-logic HORN)
(set-info :source "CHC Constraint Logic: QF_LIA
                   Contains non-linear Horn clauses: true")
(declare-fun ULTIMATE.start_ULTIMATE.startFINAL (Int Int Bool) Bool)
(declare-fun ULTIMATE.start_L11-1 (Int Int Bool) Bool)
(declare-fun f_fENTRY (Int Int Int Bool) Bool)
(declare-fun ULTIMATE.start_L11 (Int Int Bool) Bool)
(declare-fun ULTIMATE.start_ULTIMATE.startENTRY (Int Int Bool) Bool)
(declare-fun f_fFINAL (Int Int Int Bool) Bool)
(declare-fun f_L6-1 (Int Int Int Bool) Bool)
(declare-fun f_L6 (Int Int Int Bool) Bool)
(declare-fun f_fEXIT (Int Int Int Bool) Bool)
(declare-fun f_L4 (Int Int Int Bool) Bool)
(declare-fun ULTIMATE.start_ULTIMATE.startEXIT (Int Int Bool) Bool)
(assert (forall ((hhv_ULTIMATE.start_L11_0_Int Int) (hhv_ULTIMATE.start_L11_1_Int Int) (hhv_ULTIMATE.start_L11_2_Bool Bool) (hbv_ULTIMATE.start_ULTIMATE.startENTRY_0_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool Bool)) (=> (ULTIMATE.start_ULTIMATE.startENTRY hhv_ULTIMATE.start_L11_0_Int hbv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int hhv_ULTIMATE.start_L11_2_Bool) (ULTIMATE.start_L11 hhv_ULTIMATE.start_L11_0_Int hhv_ULTIMATE.start_L11_1_Int hhv_ULTIMATE.start_L11_2_Bool))))
(assert (forall ((hhv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool Bool) (hbv_ULTIMATE.start_L11-1_0_Int Int) (hbv_ULTIMATE.start_L11-1_1_Int Int) (hbv_ULTIMATE.start_L11-1_2_Bool Bool)) (=> (and (ULTIMATE.start_L11-1 hbv_ULTIMATE.start_L11-1_0_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool) (or (= hhv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int) hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool)) (ULTIMATE.start_ULTIMATE.startFINAL hhv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int hhv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool))))
(assert (forall ((hhv_f_L4_0_Int Int) (hhv_f_L4_1_Int Int) (hhv_f_L4_2_Int Int) (hhv_f_L4_3_Bool Bool) (hbv_f_fENTRY_0_Int Int) (hbv_f_fENTRY_1_Int Int) (hbv_f_fENTRY_2_Int Int) (hbv_f_fENTRY_3_Bool Bool)) (=> (and (f_fENTRY hhv_f_L4_0_Int hbv_f_fENTRY_1_Int hhv_f_L4_2_Int hhv_f_L4_3_Bool) (or hhv_f_L4_3_Bool (= hhv_f_L4_1_Int hhv_f_L4_0_Int))) (f_L4 hhv_f_L4_0_Int hhv_f_L4_1_Int hhv_f_L4_2_Int hhv_f_L4_3_Bool))))
(assert (forall ((hhv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool Bool) (hbv_ULTIMATE.start_ULTIMATE.startFINAL_0_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startFINAL_1_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startFINAL_2_Bool Bool)) (=> (ULTIMATE.start_ULTIMATE.startFINAL hhv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool) (ULTIMATE.start_ULTIMATE.startEXIT hhv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int hhv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool))))
(assert (forall ((hhv_f_fFINAL_0_Int Int) (hhv_f_fFINAL_1_Int Int) (hhv_f_fFINAL_2_Int Int) (hhv_f_fFINAL_3_Bool Bool) (hbv_f_L4_0_Int Int) (hbv_f_L4_1_Int Int) (hbv_f_L4_2_Int Int) (hbv_f_L4_3_Bool Bool)) (=> (and (or (< hhv_f_fFINAL_1_Int 3) hhv_f_fFINAL_3_Bool) (f_L4 hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool)) (f_fFINAL hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool))))
(assert (forall ((hhv_f_L6_0_Int Int) (hhv_f_L6_1_Int Int) (hhv_f_L6_2_Int Int) (hhv_f_L6_3_Bool Bool) (hbv_f_L4_0_Int Int) (hbv_f_L4_1_Int Int) (hbv_f_L4_2_Int Int) (hbv_f_L4_3_Bool Bool)) (=> (and (f_L4 hhv_f_L6_0_Int hbv_f_L4_1_Int hbv_f_L4_2_Int hhv_f_L6_3_Bool) (or (and (= hbv_f_L4_1_Int (+ hhv_f_L6_1_Int 1)) (not (< hbv_f_L4_1_Int 3))) hhv_f_L6_3_Bool)) (f_L6 hhv_f_L6_0_Int hhv_f_L6_1_Int hhv_f_L6_2_Int hhv_f_L6_3_Bool))))
(assert (forall ((hhv_f_fEXIT_0_Int Int) (hhv_f_fEXIT_1_Int Int) (hhv_f_fEXIT_2_Int Int) (hhv_f_fEXIT_3_Bool Bool) (hbv_f_fFINAL_0_Int Int) (hbv_f_fFINAL_1_Int Int) (hbv_f_fFINAL_2_Int Int) (hbv_f_fFINAL_3_Bool Bool)) (=> (f_fFINAL hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hhv_f_fEXIT_3_Bool) (f_fEXIT hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hhv_f_fEXIT_3_Bool))))
(assert (forall ((hhv_f_L6-1_0_Int Int) (hhv_f_L6-1_1_Int Int) (hhv_f_L6-1_2_Int Int) (hhv_f_L6-1_3_Bool Bool) (hbv_f_L6_0_Int Int) (hbv_f_L6_1_Int Int) (hbv_f_L6_2_Int Int) (hbv_f_L6_3_Bool Bool) (hbv_f_fEXIT_0_Int Int) (hbv_f_fEXIT_1_Int Int) (hbv_f_fEXIT_2_Int Int) (hbv_f_fEXIT_3_Bool Bool)) (=> (and (let ((.cse0 (or hbv_f_L6_3_Bool hbv_f_fEXIT_3_Bool))) (or (and hhv_f_L6-1_3_Bool .cse0) (and (not .cse0) (not hhv_f_L6-1_3_Bool)))) (= hbv_f_fEXIT_0_Int hhv_f_L6-1_1_Int) (f_L6 hhv_f_L6-1_0_Int hhv_f_L6-1_1_Int hhv_f_L6-1_2_Int hbv_f_L6_3_Bool) (f_fEXIT hbv_f_fEXIT_0_Int hbv_f_fEXIT_1_Int hbv_f_fEXIT_2_Int hbv_f_fEXIT_3_Bool)) (f_L6-1 hhv_f_L6-1_0_Int hhv_f_L6-1_1_Int hhv_f_L6-1_2_Int hhv_f_L6-1_3_Bool))))
(assert (forall ((hhv_ULTIMATE.start_L11-1_0_Int Int) (hhv_ULTIMATE.start_L11-1_1_Int Int) (hhv_ULTIMATE.start_L11-1_2_Bool Bool) (hbv_ULTIMATE.start_L11_0_Int Int) (hbv_ULTIMATE.start_L11_1_Int Int) (hbv_ULTIMATE.start_L11_2_Bool Bool) (hbv_f_fEXIT_0_Int Int) (hbv_f_fEXIT_1_Int Int) (hbv_f_fEXIT_2_Int Int) (hbv_f_fEXIT_3_Bool Bool)) (=> (and (let ((.cse0 (or hbv_ULTIMATE.start_L11_2_Bool hbv_f_fEXIT_3_Bool))) (or (and (not hhv_ULTIMATE.start_L11-1_2_Bool) (not .cse0)) (and .cse0 hhv_ULTIMATE.start_L11-1_2_Bool))) (= hbv_f_fEXIT_0_Int 4) (ULTIMATE.start_L11 hhv_ULTIMATE.start_L11-1_0_Int hhv_ULTIMATE.start_L11-1_1_Int hbv_ULTIMATE.start_L11_2_Bool) (f_fEXIT hbv_f_fEXIT_0_Int hbv_f_fEXIT_1_Int hbv_f_fEXIT_2_Int hbv_f_fEXIT_3_Bool)) (ULTIMATE.start_L11-1 hhv_ULTIMATE.start_L11-1_0_Int hhv_ULTIMATE.start_L11-1_1_Int hhv_ULTIMATE.start_L11-1_2_Bool))))
(assert (forall ((hhv_f_fEXIT_0_Int Int) (hhv_f_fEXIT_1_Int Int) (hhv_f_fEXIT_2_Int Int) (hhv_f_fEXIT_3_Bool Bool) (hbv_f_L6-1_0_Int Int) (hbv_f_L6-1_1_Int Int) (hbv_f_L6-1_2_Int Int) (hbv_f_L6-1_3_Bool Bool)) (=> (and (f_L6-1 hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hbv_f_L6-1_3_Bool) hhv_f_fEXIT_3_Bool) (f_fEXIT hhv_f_fEXIT_0_Int hhv_f_fEXIT_1_Int hhv_f_fEXIT_2_Int hhv_f_fEXIT_3_Bool))))
(assert (forall ((hhv_f_fFINAL_0_Int Int) (hhv_f_fFINAL_1_Int Int) (hhv_f_fFINAL_2_Int Int) (hhv_f_fFINAL_3_Bool Bool) (hbv_f_L6-1_0_Int Int) (hbv_f_L6-1_1_Int Int) (hbv_f_L6-1_2_Int Int) (hbv_f_L6-1_3_Bool Bool)) (=> (and (f_L6-1 hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool) hhv_f_fFINAL_3_Bool) (f_fFINAL hhv_f_fFINAL_0_Int hhv_f_fFINAL_1_Int hhv_f_fFINAL_2_Int hhv_f_fFINAL_3_Bool))))
(assert (forall ((hhv_f_fENTRY_0_Int Int) (hhv_f_fENTRY_1_Int Int) (hhv_f_fENTRY_2_Int Int) (hhv_f_fENTRY_3_Bool Bool)) (=> (not hhv_f_fENTRY_3_Bool) (f_fENTRY hhv_f_fENTRY_0_Int hhv_f_fENTRY_1_Int hhv_f_fENTRY_2_Int hhv_f_fENTRY_3_Bool))))
(assert (forall ((hhv_ULTIMATE.start_ULTIMATE.startENTRY_0_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int Int) (hhv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool Bool)) (=> (not hhv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool) (ULTIMATE.start_ULTIMATE.startENTRY hhv_ULTIMATE.start_ULTIMATE.startENTRY_0_Int hhv_ULTIMATE.start_ULTIMATE.startENTRY_1_Int hhv_ULTIMATE.start_ULTIMATE.startENTRY_2_Bool))))
(assert (forall ((hbv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int Int) (hbv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool Bool)) (=> (and (ULTIMATE.start_ULTIMATE.startEXIT hbv_ULTIMATE.start_ULTIMATE.startEXIT_0_Int hbv_ULTIMATE.start_ULTIMATE.startEXIT_1_Int hbv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool) hbv_ULTIMATE.start_ULTIMATE.startEXIT_2_Bool) false)))
(check-sat)
